/*
  UnitRepair.c - Use one battery or nanobot at a time.

  Jason Hood, 13 April, 2011 (originally One Battery, 5 April, 2011).

  Requires and assumes v1.1.
*/

#define WIN32_LEAN_AND_MEAN
#include <windows.h>

#define NAKED	__declspec(naked)
#define STDCALL __stdcall


#define ADDR_REPAIR	((PDWORD)(0x5dfd44))
#define ADDR_KEY	((PDWORD)(0x577ab2+1))


int secondary;


DWORD dummy;
#define ProtectX( addr, size ) \
  VirtualProtect( addr, size, PAGE_EXECUTE_READWRITE, &dummy )
#define ProtectW( addr, size ) \
  VirtualProtect( addr, size, PAGE_READWRITE, &dummy )

#define RELOFS( from, to ) \
  *(PDWORD)(from) = (DWORD)(to) - (DWORD)(from) - 4

#define REL2ABS( addr ) ((DWORD)(addr) + *((PDWORD)(addr)) + 4)

#define NEWOFS( from, to, prev ) \
  do { prev = REL2ABS( from ); \
       RELOFS( from, to ); } while (0)

#define NEWABS( from, to, prev ) \
  do { prev = *(PDWORD)(from); \
       *(PDWORD)(from) = (DWORD)to; } while (0)


DWORD Repair_Org, Key_Org;


NAKED
void Repair_Hook()
{
  __asm {
	cmp	secondary, 0
	je	done
	cmp	dword ptr [esp], 0x4dc88e
	je	battery
	cmp	dword ptr [esp], 0x4dc7b8
	jne	done

  //nanobot:
	mov	ebx, esi			// point to the EquipDesc

  battery:
	cmp	dword ptr [ebx+0x14], 0 	// don't think this happens,
	je	done				//  but it doesn't hurt
	push	ecx				// preserve "this"
	push	[ebx+4]
	call	dword ptr ds:[0x5c603c] 	// GetEquipment
	add	esp, 4
	test	eax, eax
	jz	done1
	fld	dword ptr [eax+0x1c]		// repair = hit_pts
	test	ebp, ebp
	jz	hull
	mov	ebx, [esi]
	mov	ecx, esi			// the shield being repaired
	call	dword ptr [ebx+0x38]		// GetMaxHitPts
	mov	ecx, esi
	call	dword ptr [ebx+0x3c]		// GetHitPts

  repair:
	pop	ecx
	fsubp	st(1), st(0)			// damage
	fcompp					// damage < repair?
	fnstsw	ax
	test	ah, 1
	jnz	partial 			// yes, don't use partial item
	mov	dword ptr [esp+8], 1		// use one item
	jmp	done

  hull:
	mov	ecx, edi			// the ship
	call	dword ptr ds:[0x5c635c] 	// get_max_hit_pts
	fld	dword ptr [edi+0xb8]		// get_hit_pts
	jmp	repair

  done1:
	pop	ecx
  done:
	jmp	Repair_Org

  partial:
	ret	12				// return value isn't used
  }
}


NAKED
void Key_Hook()
{
  __asm {
	cmp	esi, [edi+0x14] 		// primary key
	setne	byte ptr secondary
	jmp	Key_Org
  }
}


void Patch()
{
  ProtectX( ADDR_KEY,	 4 );
  ProtectW( ADDR_REPAIR, 4 );

  NEWOFS( ADDR_KEY,    Key_Hook,    Key_Org );
  NEWABS( ADDR_REPAIR, Repair_Hook, Repair_Org );
}


BOOL WINAPI DllMain( HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved )
{
  if (fdwReason == DLL_PROCESS_ATTACH)
    Patch();

  return TRUE;
}
